#ifndef IZ_INPUT_H
#define IZ_INPUT_H

#include "IZ_action.h"
#include "IZ_keyboard.h"
#include "IZ_joystick.h"
#include "IZ_midi.h"

typedef struct {
	IZ_Action action[PLAYERS];
	SDL_Event sdl_event;
	IZ_KeyboardState keyboard_state[PLAYERS];
	IZ_JoystickState joystick_state[PLAYERS];
	IZ_MIDIInputState midi_input_state[PLAYERS];
} IZ_InputState;

void IZ_HandleSDLInputEvents(SDL_Event, IZ_InputState*);

void IZ_HandlePortMIDIInputEvents(PmEvent, IZ_InputState*);

void IZ_InitializeInput(const char*, IZ_InputState*);

void IZ_TeardownInput(IZ_InputState*);

#endif
