#ifndef IZ_MIDI_H
#define IZ_MIDI_H

#include <string.h>
#include <portmidi.h>
#include <minIni.h>
#include "IZ_action.h"

#define MIDI_EVENT_BUFFER_SIZE 1024

typedef uint8_t IZ_MIDINote;

static const uint8_t IZ_MIDI_NOTE_ON = 0x90u;

static const uint8_t IZ_MIDI_NOTE_OFF = 0x80u;

typedef struct {
	PmDeviceID device_id;
	IZ_MIDINote control_mapping[CONTROLS];
} IZ_MIDIInputConfig;

typedef struct {
	IZ_MIDIInputConfig config;
	const PmDeviceInfo* device_info;
	PmStream* stream;
	PmEvent event_buffer[MIDI_EVENT_BUFFER_SIZE];
} IZ_MIDIInputState;

static const IZ_MIDINote IZ_DEFAULT_MIDI_INPUT_CONTROLS[PLAYERS][CONTROLS] = {
	{
		70,
		72,
		71,
		69,
		77,
		76,
		48,
		49,
		50,
		51,
		52,
		53,
		54,
		55,
		56,
		57,
	}
};

IZ_ProcedureResult IZ_SaveMIDIInputConfig(const char*, IZ_MIDIInputState(*)[PLAYERS]);

void IZ_HandleMIDIInputEvents(PmEvent, IZ_MIDIInputState(*)[PLAYERS], IZ_Action(*)[PLAYERS]);

IZ_ProcedureResult IZ_InitializeMIDIInput(const char*, IZ_MIDIInputState(*)[PLAYERS]);

void IZ_TeardownMIDIInput(IZ_MIDIInputState(*)[PLAYERS]);

#endif
