#ifndef IZ_VIDEO_H
#define IZ_VIDEO_H

#include <stdio.h>
#include <minIni.h>
#include <SDL_video.h>

// TODO move this out from video, refer to app's state instead
#include "../input/IZ_input.h"
#include "../IZ_common.h"
#include "../IZ_config.h"

typedef struct {
	uint16_t width;
	uint16_t  height;
	uint8_t max_fps;
} IZ_VideoConfig;

typedef struct {
	IZ_VideoConfig config;
	uint64_t last_update_at;
	SDL_Window* window;
	SDL_Surface* surface;
} IZ_VideoState;

IZ_ProcedureResult IZ_InitializeVideo(const char*, IZ_VideoState*);

IZ_ProcedureResult IZ_SaveVideoConfig(const char*, IZ_VideoConfig*);

void IZ_UpdateVideo(IZ_VideoState*, IZ_InputState*, uint64_t);

void IZ_TeardownVideo(IZ_VideoState*);

#endif
